<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2021-12-03 Fri 15:43 -->
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Ssh</title>
<meta name="author" content="dt" />
<meta name="description" content="Knowledge Base - ssh
Header
Header" />
<meta name="generator" content="Org Mode" />
<style>
  #content { max-width: 60em; margin: auto; }
  .title  { text-align: center;
             margin-bottom: .2em; }
  .subtitle { text-align: center;
              font-size: medium;
              font-weight: bold;
              margin-top:0; }
  .todo   { font-family: monospace; color: red; }
  .done   { font-family: monospace; color: green; }
  .priority { font-family: monospace; color: orange; }
  .tag    { background-color: #eee; font-family: monospace;
            padding: 2px; font-size: 80%; font-weight: normal; }
  .timestamp { color: #bebebe; }
  .timestamp-kwd { color: #5f9ea0; }
  .org-right  { margin-left: auto; margin-right: 0px;  text-align: right; }
  .org-left   { margin-left: 0px;  margin-right: auto; text-align: left; }
  .org-center { margin-left: auto; margin-right: auto; text-align: center; }
  .underline { text-decoration: underline; }
  #postamble p, #preamble p { font-size: 90%; margin: .2em; }
  p.verse { margin-left: 3%; }
  pre {
    border: 1px solid #e6e6e6;
    border-radius: 3px;
    background-color: #f2f2f2;
    padding: 8pt;
    font-family: monospace;
    overflow: auto;
    margin: 1.2em;
  }
  pre.src {
    position: relative;
    overflow: auto;
  }
  pre.src:before {
    display: none;
    position: absolute;
    top: -8px;
    right: 12px;
    padding: 3px;
    color: #555;
    background-color: #f2f2f299;
  }
  pre.src:hover:before { display: inline; margin-top: 14px;}
  /* Languages per Org manual */
  pre.src-asymptote:before { content: 'Asymptote'; }
  pre.src-awk:before { content: 'Awk'; }
  pre.src-authinfo::before { content: 'Authinfo'; }
  pre.src-C:before { content: 'C'; }
  /* pre.src-C++ doesn't work in CSS */
  pre.src-clojure:before { content: 'Clojure'; }
  pre.src-css:before { content: 'CSS'; }
  pre.src-D:before { content: 'D'; }
  pre.src-ditaa:before { content: 'ditaa'; }
  pre.src-dot:before { content: 'Graphviz'; }
  pre.src-calc:before { content: 'Emacs Calc'; }
  pre.src-emacs-lisp:before { content: 'Emacs Lisp'; }
  pre.src-fortran:before { content: 'Fortran'; }
  pre.src-gnuplot:before { content: 'gnuplot'; }
  pre.src-haskell:before { content: 'Haskell'; }
  pre.src-hledger:before { content: 'hledger'; }
  pre.src-java:before { content: 'Java'; }
  pre.src-js:before { content: 'Javascript'; }
  pre.src-latex:before { content: 'LaTeX'; }
  pre.src-ledger:before { content: 'Ledger'; }
  pre.src-lisp:before { content: 'Lisp'; }
  pre.src-lilypond:before { content: 'Lilypond'; }
  pre.src-lua:before { content: 'Lua'; }
  pre.src-matlab:before { content: 'MATLAB'; }
  pre.src-mscgen:before { content: 'Mscgen'; }
  pre.src-ocaml:before { content: 'Objective Caml'; }
  pre.src-octave:before { content: 'Octave'; }
  pre.src-org:before { content: 'Org mode'; }
  pre.src-oz:before { content: 'OZ'; }
  pre.src-plantuml:before { content: 'Plantuml'; }
  pre.src-processing:before { content: 'Processing.js'; }
  pre.src-python:before { content: 'Python'; }
  pre.src-R:before { content: 'R'; }
  pre.src-ruby:before { content: 'Ruby'; }
  pre.src-sass:before { content: 'Sass'; }
  pre.src-scheme:before { content: 'Scheme'; }
  pre.src-screen:before { content: 'Gnu Screen'; }
  pre.src-sed:before { content: 'Sed'; }
  pre.src-sh:before { content: 'shell'; }
  pre.src-sql:before { content: 'SQL'; }
  pre.src-sqlite:before { content: 'SQLite'; }
  /* additional languages in org.el's org-babel-load-languages alist */
  pre.src-forth:before { content: 'Forth'; }
  pre.src-io:before { content: 'IO'; }
  pre.src-J:before { content: 'J'; }
  pre.src-makefile:before { content: 'Makefile'; }
  pre.src-maxima:before { content: 'Maxima'; }
  pre.src-perl:before { content: 'Perl'; }
  pre.src-picolisp:before { content: 'Pico Lisp'; }
  pre.src-scala:before { content: 'Scala'; }
  pre.src-shell:before { content: 'Shell Script'; }
  pre.src-ebnf2ps:before { content: 'ebfn2ps'; }
  /* additional language identifiers per "defun org-babel-execute"
       in ob-*.el */
  pre.src-cpp:before  { content: 'C++'; }
  pre.src-abc:before  { content: 'ABC'; }
  pre.src-coq:before  { content: 'Coq'; }
  pre.src-groovy:before  { content: 'Groovy'; }
  /* additional language identifiers from org-babel-shell-names in
     ob-shell.el: ob-shell is the only babel language using a lambda to put
     the execution function name together. */
  pre.src-bash:before  { content: 'bash'; }
  pre.src-csh:before  { content: 'csh'; }
  pre.src-ash:before  { content: 'ash'; }
  pre.src-dash:before  { content: 'dash'; }
  pre.src-ksh:before  { content: 'ksh'; }
  pre.src-mksh:before  { content: 'mksh'; }
  pre.src-posh:before  { content: 'posh'; }
  /* Additional Emacs modes also supported by the LaTeX listings package */
  pre.src-ada:before { content: 'Ada'; }
  pre.src-asm:before { content: 'Assembler'; }
  pre.src-caml:before { content: 'Caml'; }
  pre.src-delphi:before { content: 'Delphi'; }
  pre.src-html:before { content: 'HTML'; }
  pre.src-idl:before { content: 'IDL'; }
  pre.src-mercury:before { content: 'Mercury'; }
  pre.src-metapost:before { content: 'MetaPost'; }
  pre.src-modula-2:before { content: 'Modula-2'; }
  pre.src-pascal:before { content: 'Pascal'; }
  pre.src-ps:before { content: 'PostScript'; }
  pre.src-prolog:before { content: 'Prolog'; }
  pre.src-simula:before { content: 'Simula'; }
  pre.src-tcl:before { content: 'tcl'; }
  pre.src-tex:before { content: 'TeX'; }
  pre.src-plain-tex:before { content: 'Plain TeX'; }
  pre.src-verilog:before { content: 'Verilog'; }
  pre.src-vhdl:before { content: 'VHDL'; }
  pre.src-xml:before { content: 'XML'; }
  pre.src-nxml:before { content: 'XML'; }
  /* add a generic configuration mode; LaTeX export needs an additional
     (add-to-list 'org-latex-listings-langs '(conf " ")) in .emacs */
  pre.src-conf:before { content: 'Configuration File'; }

  table { border-collapse:collapse; }
  caption.t-above { caption-side: top; }
  caption.t-bottom { caption-side: bottom; }
  td, th { vertical-align:top;  }
  th.org-right  { text-align: center;  }
  th.org-left   { text-align: center;   }
  th.org-center { text-align: center; }
  td.org-right  { text-align: right;  }
  td.org-left   { text-align: left;   }
  td.org-center { text-align: center; }
  dt { font-weight: bold; }
  .footpara { display: inline; }
  .footdef  { margin-bottom: 1em; }
  .figure { padding: 1em; }
  .figure p { text-align: center; }
  .equation-container {
    display: table;
    text-align: center;
    width: 100%;
  }
  .equation {
    vertical-align: middle;
  }
  .equation-label {
    display: table-cell;
    text-align: right;
    vertical-align: middle;
  }
  .inlinetask {
    padding: 10px;
    border: 2px solid gray;
    margin: 10px;
    background: #ffffcc;
  }
  #org-div-home-and-up
   { text-align: right; font-size: 70%; white-space: nowrap; }
  textarea { overflow-x: auto; }
  .linenr { font-size: smaller }
  .code-highlighted { background-color: #ffff00; }
  .org-info-js_info-navigation { border-style: none; }
  #org-info-js_console-label
    { font-size: 10px; font-weight: bold; white-space: nowrap; }
  .org-info-js_search-highlight
    { background-color: #ffff00; color: #000000; font-weight: bold; }
  .org-svg { width: 90%; }
</style>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/htmlize.css"/>
<link rel="stylesheet" type="text/css" href="https://distro.tube/org-html-themes/src/readtheorg_theme/css/readtheorg.css"/>
<script src="httpss://ajax.googleapis.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
<script src="httpss://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/lib/js/jquery.stickytableheaders.min.js"></script>
<script type="text/javascript" src="https://distro.tube/org-html-themes/src/readtheorg_theme/js/readtheorg.js"></script>
</head>
<body>
<div id="content" class="content">
<h1 class="title">Ssh</h1>
<div id="table-of-contents" role="doc-toc">
<h2>Table of Contents</h2>
<div id="text-table-of-contents" role="doc-toc">
<ul>
<li><a href="#org61ffb90">Introduction</a>
<ul>
<li><a href="#org7d28e23">What is SSH?</a></li>
<li><a href="#orge5e14f6">How does SSH work?</a></li>
</ul>
</li>
<li><a href="#org3250f49">Installing SSH</a>
<ul>
<li><a href="#org8afc2e0">What packages are needed?</a></li>
<li><a href="#org51da2b5">Enable SSH</a></li>
<li><a href="#orge0769ee">Stopping and starting SSH</a></li>
<li><a href="#org4e654c2">SSH keys</a></li>
<li><a href="#org71e161a">Disabling password SSH authentication</a></li>
<li><a href="#org19dda14">Disabling root login</a></li>
</ul>
</li>
<li><a href="#orge34240c">SSH Command Line Basics</a></li>
<li><a href="#org8118e62">SSH Clients for Linux</a>
<ul>
<li><a href="#org8002abf">Footer</a></li>
</ul>
</li>
</ul>
</div>
</div>
<table border="2" cellspacing="0" cellpadding="6" rules="groups" frame="hsides">


<colgroup>
<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-left"><a href="../index.html">Home</a></td>
<td class="org-left"><a href="../dtos/index.html">DTOS</a></td>
<td class="org-left"><a href="index.html">Knowledge Base</a></td>
<td class="org-left"><a href="../community/index.html">Community</a></td>
<td class="org-left"><a href="../contribute/index.html">Contribute</a></td>
<td class="org-left"><a href="../support/index.html">Support DT&rsquo;s Work</a></td>
</tr>
</tbody>
</table>

<div id="outline-container-org61ffb90" class="outline-2">
<h2 id="org61ffb90">Introduction</h2>
<div class="outline-text-2" id="text-org61ffb90">
</div>
<div id="outline-container-org7d28e23" class="outline-3">
<h3 id="org7d28e23">What is SSH?</h3>
<div class="outline-text-3" id="text-org7d28e23">
<p>
SSH (the Secure Shell) is a program for logging into a remote machine and for executing commands on a remote machine.  It&rsquo;s the most popular way to access a remote Linux or BSD server, although SSH also works on Windows.  It is intended to provide secure encrypted communications between two untrusted hosts over an insecure network.
</p>
</div>
</div>
<div id="outline-container-orge5e14f6" class="outline-3">
<h3 id="orge5e14f6">How does SSH work?</h3>
<div class="outline-text-3" id="text-orge5e14f6">
<p>
On the server, you have an SSH daemon that is constantly listening to a specific TCP/IP port for possible client connection requests.  Once a client initiates a connection, the SSH daemon will respond and the two machines will exchange their identification data.  Once a connection is established, your command prompt will change from user@host on your local machine to remote-user@remote-host.  The commands you enter will now affect the remote machine rather than your local machine.
</p>
</div>
</div>
</div>
<div id="outline-container-org3250f49" class="outline-2">
<h2 id="org3250f49">Installing SSH</h2>
<div class="outline-text-2" id="text-org3250f49">
</div>
<div id="outline-container-org8afc2e0" class="outline-3">
<h3 id="org8afc2e0">What packages are needed?</h3>
<div class="outline-text-3" id="text-org8afc2e0">
<ul class="org-ul">
<li>You need the openssh-server (Ubuntu) package installed on the machine that acts as the server (the remote machine).</li>
<li>You need the openssh-client (Ubuntu) package installed on the machine that acts as the client (your local computer).</li>
<li>On Arch Linux, just install the openssh package. It has both the server and client functionality.</li>
</ul>
</div>
</div>
<div id="outline-container-org51da2b5" class="outline-3">
<h3 id="org51da2b5">Enable SSH</h3>
<div class="outline-text-3" id="text-org51da2b5">
<ul class="org-ul">
<li>sudo systemctl status ssh (it should read <code>active</code>)</li>
<li>If it&rsquo;s not running, then: sudo systemctl enable &#x2013;now ssh</li>
<li>If using ufw (the uncomplicated firewall): sudo ufw allow ssh
<code>NOTE:</code> It is very important not to disable SSH on the remote machine if that is your only way into it.</li>
</ul>
</div>
</div>
<div id="outline-container-orge0769ee" class="outline-3">
<h3 id="orge0769ee">Stopping and starting SSH</h3>
<div class="outline-text-3" id="text-orge0769ee">
<ul class="org-ul">
<li>Stop SSH with: sudo systemctl stop ssh</li>
<li>Start SSH with: sudo systemctl start ssh</li>
<li>Disable SSH with: sudo systemctl disable ssh
<code>NOTE:</code> This will not disable current session but it will prevent you from logging into the machine in the future.  It is very important not to disable SSH on the remote machine if that is your only way into it.</li>
</ul>
</div>
</div>
<div id="outline-container-org4e654c2" class="outline-3">
<h3 id="org4e654c2">SSH keys</h3>
<div class="outline-text-3" id="text-org4e654c2">
<ul class="org-ul">
<li>Create key pair on client machine: ssh-keygen -t ed25519</li>
<li>Enter file in which to save the key (<i>home/sammy</i>.ssh/id_ed25519): Go with default name or change it if you wish.</li>
<li>Enter passphrase (empty for no passphrase): Up to you to do this or not, but it&rsquo;s strongly recommended.</li>
</ul>
<p>
<code>NOTE:</code> Should a private key with no passphrase fall into an unauthorized user’s possession, they will be able to log in to any server you’ve configured with the associated public key.
</p>
<ul class="org-ul">
<li>Copy public key to server: ssh-copy-id sammy@your_server_address
You can copy the public key into the server’s authorized_keys file with the ssh-copy-id command. Once the command completes, you will be able to log into the server via SSH without being prompted for a password. However, if you set a passphrase when creating your SSH key, you will be asked to enter the passphrase at that time. This is your local ssh client asking you to decrypt the private key, it is not the remote server asking for a password.</li>
</ul>
</div>
</div>
<div id="outline-container-org71e161a" class="outline-3">
<h3 id="org71e161a">Disabling password SSH authentication</h3>
<div class="outline-text-3" id="text-org71e161a">
<ul class="org-ul">
<li>sudo vim /etc/ssh/sshd_config</li>
<li>PasswordAuthentication no (also make sure line isn&rsquo;t commented with a #)</li>
<li>sudo systemctl reload sshd (to put config changes into effect)</li>
</ul>
<p>
<code>Warning:</code> before you disable password-based authentication, be certain you can successfully log onto the server with your SSH key, and that there are no other users on the server using passwords to log in.
</p>
</div>
</div>
<div id="outline-container-org19dda14" class="outline-3">
<h3 id="org19dda14">Disabling root login</h3>
<div class="outline-text-3" id="text-org19dda14">
<ul class="org-ul">
<li>sudo vim /etc/ssh/sshd_config</li>
<li>PermitRootLogin no</li>
<li>AllowUsers derek (or whatever user name)</li>
</ul>
</div>
</div>
</div>
<div id="outline-container-orge34240c" class="outline-2">
<h2 id="orge34240c">SSH Command Line Basics</h2>
<div class="outline-text-2" id="text-orge34240c">
<ul class="org-ul">
<li>ssh username@address (username on remote machine; address is IP or domain of remote machine)</li>
<li>Don&rsquo;t know the IP?  On the remote machine, type: ip a</li>
<li>With web hosting, you should receive the IP address when creating your server.</li>
<li>The first time you connect, it will ask for permission to add the host.  Type <code>yes</code>.</li>
<li>SSH tells you that host was permanently added and then asks for the remote user&rsquo;s password.  Enter <code>password</code>.</li>
<li>You&rsquo;re now connected.</li>
<li>Enable SSH with: sudo systemctl enable ssh  (&#x2013;now if also want it started)</li>
<li>To exit, type: <code>exit</code></li>
</ul>
</div>
</div>
<div id="outline-container-org8118e62" class="outline-2">
<h2 id="org8118e62">SSH Clients for Linux</h2>
<div class="outline-text-2" id="text-org8118e62">
<p>
There are clients for Windows and Android.  I haven&rsquo;t used them.  There&rsquo;s also some proprietary SSH clients available for Linux.  I haven&rsquo;t used them either.  I have only used the following free and open source SSH clients.
</p>
<ul class="org-ul">
<li>Emacs</li>
<li>Remmina</li>
</ul>
</div>

<div id="outline-container-org8002abf" class="outline-3">
<h3 id="org8002abf">Footer</h3>
<div class="outline-text-3" id="text-org8002abf">
<p>
Copyright © 2020-2021 Derek Taylor (DistroTube)
</p>

<p>
This page is licensed under a <a href="https://creativecommons.org/licenses/by-nd/4.0/">Creative Commons Attribution-NoDerivatives 4.0 International License</a> (CC-BY-ND 4.0).
</p>

<p>
The source code for distro.tube can be found on <a href="https://gitlab.com/dwt1/distro.tube">GitLab</a>.  User-submitted contributions to the site are welcome, as long as the contributor agrees to license their submission with the CC-BY-ND 4.0 license.
</p>
</div>
</div>
</div>
</div>
<div id="postamble" class="status">
<p class="author">Author: dt</p>
<p class="date">Created: 2021-12-03 Fri 15:43</p>
</div>
</body>
</html>
